﻿using UnityEngine;
using System.Collections;	
using CP = ChipmunkBinding;
using System;
using System.Runtime.InteropServices;

public class ChipmunkLayers : MonoBehaviour {
	
	private int _allLayers = ~0;
		
//#if UNITY_EDITOR

	public bool _layer1 = true;
	public bool _layer2 = true;
	public bool _layer3 = true;
	public bool _layer4 = true;
	public bool _layer5 = true;
	public bool _layer6 = true;
	public bool _layer7 = true;
	public bool _layer8 = true;
	public bool _layer9 = true;
	public bool _layer10 = true;
	public bool _layer11 = true;
	public bool _layer12 = true;
	public bool _layer13 = true;
	public bool _layer14 = true;
	public bool _layer15 = true;
	public bool _layer16 = true;
	public bool _layer17 = true;
	public bool _layer18 = true;
	public bool _layer19 = true;
	public bool _layer20 = true;
	public bool _layer21 = true;
	public bool _layer22 = true;
	public bool _layer23 = true;
	public bool _layer24 = true;
	public bool _layer25 = true;
	public bool _layer26 = true;
	public bool _layer27 = true;
	public bool _layer28 = true;
	public bool _layer29 = true;
	public bool _layer30 = true;
	public bool _layer31 = true;
	public bool _layer32 = true;
//#endif

	/// Radius of circle relative to it's transform.
	public int allLayers {
		get {
			ChipmunkShape[] shapes = GetComponents<ChipmunkShape>();

			int layers = _allLayers;

			// Only return common bits
			foreach (ChipmunkShape shape in shapes)
				layers &= (int)CP._cpShapeGetLayers(shape._handle);

			return layers; 	                            
		}
		set {
			_allLayers = value;

			ChipmunkShape[] shapes = GetComponents<ChipmunkShape>();

			foreach (ChipmunkShape shape in shapes)
				CP._cpShapeSetLayers(shape._handle, (uint)value);
		}
	}

	private void setLayer(int layerNum, bool enable) {
		int layer = (1 << layerNum);

		if (enable) {
			this.allLayers = (_allLayers | layer);
		} else {
			this.allLayers = (_allLayers & ~layer);
		}
	}

	private bool getLayerEnabled(int layerNum) {
		return (_allLayers & (1 << layerNum)) != 0;
	}

	public bool layer1 {
		get {
			return this.getLayerEnabled(0);
		}
		set {
			this.setLayer(0, value);
		}
	}

	public bool layer2 {
		get {
			return this.getLayerEnabled(1);
		}
		set {
			this.setLayer(1, value);
		}
	}

	public bool layer3 {
		get {
			return this.getLayerEnabled(2);
		}
		set {
			this.setLayer(2, value);
		}
	}
	
	public bool layer4 {
		get {
			return this.getLayerEnabled(3);
		}
		set {
			this.setLayer(3, value);
		}
	}
	
	public bool layer5 {
		get {
			return this.getLayerEnabled(4);
		}
		set {
			this.setLayer(4, value);
		}
	}
	
	public bool layer6 {
		get {
			return this.getLayerEnabled(5);
		}
		set {
			this.setLayer(5, value);
		}
	}
	
	public bool layer7 {
		get {
			return this.getLayerEnabled(6);
		}
		set {
			this.setLayer(6, value);
		}
	}
	
	public bool layer8 {
		get {
			return this.getLayerEnabled(7);
		}
		set {
			this.setLayer(7, value);
		}
	}
	
	public bool layer9 {
		get {
			return this.getLayerEnabled(8);
		}
		set {
			this.setLayer(8, value);
		}
	}
	
	public bool layer10 {
		get {
			return this.getLayerEnabled(9);
		}
		set {
			this.setLayer(9, value);
		}
	}
	
	public bool layer11 {
		get {
			return this.getLayerEnabled(10);
		}
		set {
			this.setLayer(10, value);
		}
	}
	
	public bool layer12 {
		get {
			return this.getLayerEnabled(11);
		}
		set {
			this.setLayer(11, value);
		}
	}
	
	public bool layer13 {
		get {
			return this.getLayerEnabled(12);
		}
		set {
			this.setLayer(12, value);
		}
	}
	
	public bool layer14 {
		get {
			return this.getLayerEnabled(13);
		}
		set {
			this.setLayer(13, value);
		}
	}
	
	public bool layer15 {
		get {
			return this.getLayerEnabled(14);
		}
		set {
			this.setLayer(14, value);
		}
	}
	
	public bool layer16 {
		get {
			return this.getLayerEnabled(15);
		}
		set {
			this.setLayer(15, value);
		}
	}
	
	public bool layer17 {
		get {
			return this.getLayerEnabled(16);
		}
		set {
			this.setLayer(16, value);
		}
	}
	
	public bool layer18 {
		get {
			return this.getLayerEnabled(17);
		}
		set {
			this.setLayer(17, value);
		}
	}
	
	public bool layer19 {
		get {
			return this.getLayerEnabled(18);
		}
		set {
			this.setLayer(18, value);
		}
	}
	
	public bool layer20 {
		get {
			return this.getLayerEnabled(19);
		}
		set {
			this.setLayer(19, value);
		}
	}
	
	public bool layer21 {
		get {
			return this.getLayerEnabled(20);
		}
		set {
			this.setLayer(20, value);
		}
	}
	
	public bool layer22 {
		get {
			return this.getLayerEnabled(21);
		}
		set {
			this.setLayer(21, value);
		}
	}
	
	public bool layer23 {
		get {
			return this.getLayerEnabled(22);
		}
		set {
			this.setLayer(22, value);
		}
	}
	
	public bool layer24 {
		get {
			return this.getLayerEnabled(23);
		}
		set {
			this.setLayer(23, value);
		}
	}
	
	public bool layer25 {
		get {
			return this.getLayerEnabled(24);
		}
		set {
			this.setLayer(24, value);
		}
	}
	
	public bool layer26 {
		get {
			return this.getLayerEnabled(25);
		}
		set {
			this.setLayer(25, value);
		}
	}
	
	public bool layer27 {
		get {
			return this.getLayerEnabled(26);
		}
		set {
			this.setLayer(26, value);
		}
	}
	
	public bool layer28 {
		get {
			return this.getLayerEnabled(27);
		}
		set {
			this.setLayer(27, value);
		}
	}
	
	public bool layer29 {
		get {
			return this.getLayerEnabled(28);
		}
		set {
			this.setLayer(28, value);
		}
	}
	
	public bool layer30 {
		get {
			return this.getLayerEnabled(29);
		}
		set {
			this.setLayer(29, value);
		}
	}
	
	public bool layer31 {
		get {
			return this.getLayerEnabled(30);
		}
		set {
			this.setLayer(30, value);
		}
	}
	
	public bool layer32 {
		get {
			return this.getLayerEnabled(31);
		}
		set {
			this.setLayer(31, value);
		}
	}

	// Use this for initialization
	void Start () {	
//#if UNITY_EDITOR
		this.layer1 = _layer1;
		this.layer2 = _layer2;
		this.layer3 = _layer3;
		this.layer4 = _layer4;
		this.layer5 = _layer5;
		this.layer6 = _layer6;
		this.layer7 = _layer7;
		this.layer8 = _layer8;
		this.layer9 = _layer9;
		this.layer10 = _layer10;
		this.layer11 = _layer11;
		this.layer12 = _layer12;
		this.layer13 = _layer13;
		this.layer14 = _layer14;
		this.layer15 = _layer15;
		this.layer16 = _layer16;
		this.layer17 = _layer17;
		this.layer18 = _layer18;
		this.layer19 = _layer19;
		this.layer20 = _layer20;
		this.layer21 = _layer21;
		this.layer22 = _layer22;
		this.layer23 = _layer23;
		this.layer24 = _layer24;
		this.layer25 = _layer25;
		this.layer26 = _layer26;
		this.layer27 = _layer27;
		this.layer28 = _layer28;
		this.layer29 = _layer29;
		this.layer30 = _layer30;
		this.layer31 = _layer31;
		this.layer32 = _layer32;
//#endif
	}
	
	// Update is called once per frame
	void Update () {
	}
}
